<!-- manual page source format generated by PolyglotMan v3.0.7, -->
<!-- available via anonymous ftp from ftp.cs.berkeley.edu:/ucb/people/phelps/tcltk/rman.tar.Z -->

<HTML>
<HEAD>
<TITLE>Man page for fixfortran.1</TITLE>
</HEAD>
<BODY bgcolor=white>
<A HREF="#toc">Table of Contents</A><P>

<H2><A NAME="sect0" HREF="#toc0">Name</A></H2>

<P>
fixfortran - final processing for the SUIF Fortran 77
front end

<H2><A NAME="sect1" HREF="#toc1"><B>Synopsis</B></A></H2>

<P>
<B>fixfortran</B> <I>infile</I> <I>outfile</I>

<H2><A NAME="sect2" HREF="#toc2"><B>Description</B></A></H2>

<P>
The <I>fixfortran</I> program forms the last of four passes that
constitute the SUIF front end for Fortran 77. The first
three passes are <I>sf2c,</I> <I>cpp</I> (the standard C pre-processor,
not SUIF specific), and <I>snoot.</I> The process is as follows:
The <I>sf2c</I> pass converts from Fortran to a special form of C
that retains some special Fortran information, including
the Fortran array types, encoded in C constructs such as
variables with special names. The <I>cpp</I> and <I>snoot</I> passes
convert from this C code directly to the corresponding
SUIF representation. These two C passes have no knowledge
of the Fortran information. Then fixfortran converts from
the SUIF representation of C code to a representation of
Fortran that reconstructs critical Fortran information
that was encoded in the C representation.
<P>
This scheme allows us to take advantage of an existing Cto-SUIF
converter and most of an existing Fortran-to-C
converter. By making some modifications to the Fortranto-C
converter and adding this pass, we can get back the
most important Fortran information while re-using all the
existing code.
<P>
It is essential that <I>fixfortran</I> is run immediately after
<I>snoot.</I> Any other pass might change the code in such a way
that <I>fixfortran</I> will not find the very specially patterned
code sf2c uses to encode the Fortran information. <I>fixfor</I><B>_</B>t<I>ran</I>
will also be entirely confused and unable to function
if run on code that was originally C not produced by sf2c.
In either case, fixfortran will likely fail with an error
message and even if it does produce an output file, the
resulting code is likely to be incorrect.

<H2><A NAME="sect3" HREF="#toc3"><B>See</B> <B>Also</B></A></H2>

<P>
<A HREF="man_sf2c.1.html">sf2c(1)</A>
, <A HREF="man_cpp.1.html">cpp(1)</A>
, <A HREF="man_snoot.1.html">snoot(1)</A>


<H2><A NAME="sect4" HREF="#toc4"><B>History</B></A></H2>

<P>
This program was written by Chris Wilson. Before it
existed, some of its functionality was implemented in earlier
versions of the C front end, <I>snoot</I> and <I>snout.</I>
<P>

<HR><P>
<A NAME="toc"><B>Table of Contents</B></A><P>
<UL>
<LI><A NAME="toc0" HREF="#sect0">Name</A></LI>
<LI><A NAME="toc1" HREF="#sect1">Synopsis</A></LI>
<LI><A NAME="toc2" HREF="#sect2">Description</A></LI>
<LI><A NAME="toc3" HREF="#sect3">See Also</A></LI>
<LI><A NAME="toc4" HREF="#sect4">History</A></LI>
</UL>
</BODY></HTML>
